import os


class Message(object):
    """
    A Message object that holds a few important strings
    """
    Channel = str() # the channel in which the message was found
    Time = str() # the time where which the message was sent
    User = str() # the user who sent the message
    Message = str() # the message part of the raw line
    Raw_Message = str() # the raw line unparsed and unchanged

    def __init__(self, string, filename, *args, **kwargs):
        self.create_from_string(string, filename)

    def create_from_string(self, string, filename):
        self.Raw_Message = string
        self.Channel = os.path.basename(filename).replace(".log", "")
        self.Time = string[:15]
        self.User = string[string.find("<")+1:string.find(">")]
        self.Message = string[string.find(">")+2:]


class XChatMessage(Message):
    """
    A Message object that holds a few important strings that decodes xchat logs
    """
    Channel = str() # the channel in which the message was found
    Time = str() # the time where which the message was sent
    User = str() # the user who sent the message
    Message = str() # the message part of the raw line
    Raw_Message = str() # the raw line unparsed and unchanged
    xchat = {"TimeCharacters" : 15, "UserSeperators" : ["<",">"]}

    def __init__(self, string, filename, *args, **kwargs):
        self.create_from_string(string, filename)

    def create_from_string(self, string, filename):
        self.Raw_Message = string
        self.Channel = os.path.basename(filename).replace(".log", "")
        self.Time = string[:self.xchat["TimeCharacters"]]
        self.User = string[string.find(self.xchat["UserSeperators"][0])+1:string.find(self.xchat["UserSeperators"][1])]
        self.Message = string[string.find(self.xchat["UserSeperators"][1])+2:]